/* $Id: Sin.java,v 1.5 2010/09/25 07:11:42 mit Exp $ */
/* Sin1.java to Sin.java */
import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.text.DecimalFormat;

public class Sin extends Applet implements AdjustmentListener
{
    private Scrollbar scrX;
    final int L = 40;      // Ĺ
    final int P = 20;      // ܿ

    int W;
    int H;
    int Spoint;
    DecimalFormat df1;

    public void init() {
	setFont(new Font("SansSerif", Font.PLAIN, 12));
        setBackground(Color.lightGray);
	setLayout(new BorderLayout());
	df1 = new DecimalFormat("#0.0#");

        Panel p = new Panel();
        p.setLayout(new GridLayout(1,2,0,0));

        scrX = new Scrollbar(Scrollbar.HORIZONTAL,L/2,1,1,L);
        p.add(scrX);
	scrX.addAdjustmentListener(this);

        p.add(new Label(" : Striking Point"));
        add(p, "South");
    }
    public void start() {
	W = getSize().width;
        H = getSize().height;
    }
    public String dform(double n) {
        return df1.format((float)n);
    }
    public void adjustmentValueChanged(AdjustmentEvent e) {
        repaint();
    }

    public void update(Graphics g) {
        paint(g);
    }
    public void paint(Graphics g) {
	int hh = (int)(H*2/3d);
	int ws = 26;
	double xd = (W-ws)/(double)P;
	int dh = (int)(H/3d);
	int xs = ws/2;

	Spoint = scrX.getValue(); // Ǹ

	g.setColor(Color.black);
        g.fillRect(0, 0, W, H);

	g.setColor(Color.blue);
        g.drawLine(0, hh, W, hh);  
	g.drawLine(xs, 0, xs, H);
	
	g.setColor(Color.red);
	g.drawString("Striking Point: 1/"+
		     dform(1.0/(Spoint/(double)L)), 20, 20);

	int x1, y1;
	for (int i = 0; i <= P; i++) {
	    x1 = (int)(xs+i*xd);
	    y1 = (int)(yys(i)*dh);

	    g.setColor(Color.green);
	    g.fillRect(x1-1, hh-y1, 3, y1);

	    g.setColor(Color.blue);
	    g.drawLine(x1, hh, x1, hh+8);

	    if (i % 5 == 0) {
		g.drawLine(x1, hh, x1, hh+16);

		g.setColor(Color.magenta);
		g.drawString(""+i, x1, hh+26);
	    }
	}
    }

    public double yys(int m) {
	return Math.abs(Math.sin(m*Math.PI*Spoint/L));
    }
}
